//
//  TestView.m
//  NoodleGradientTest
//
//  Created by Paul Kim on 10/11/06.
//  Copyright 2006 Paul Kim d/b/a Noodlesoft. All rights reserved.
//

#import "TestView.h"
#import "NSBezierPath-NoodleGradient.h"

#define BORDER		100
#define SHAPE_WIDTH		50

@implementation TestView

- (BOOL)isFlipped
{
	return NO;
}

- (void)drawRect:(NSRect)aRect
{
	NSAffineTransform	*transform;
	NSBezierPath		*path;
	NSRect				bounds;
	float				halfWidth, halfHeight;
	
	bounds = [self bounds];
	halfWidth = NSWidth(bounds) / 2;
	halfHeight = NSHeight(bounds) / 2;
	transform = [NSAffineTransform transform];
	[transform translateXBy:NSMinX(bounds) + halfWidth yBy:NSMinY(bounds) + halfHeight];
	[transform rotateByDegrees:angle];
	[transform translateXBy:-(NSMinX(bounds) + halfWidth) yBy:-(NSMinY(bounds) + halfHeight)];
	[transform concat];
	
	path = [NSBezierPath bezierPath];
	
	bounds = NSInsetRect(bounds, BORDER, BORDER);
	
	[path moveToPoint:NSMakePoint(NSMinX(bounds), NSMinY(bounds))];
	[path lineToPoint:NSMakePoint(NSMinX(bounds), NSMaxY(bounds))];
	[path lineToPoint:NSMakePoint(NSMinX(bounds) + SHAPE_WIDTH, NSMaxY(bounds))];
	[path lineToPoint:NSMakePoint(NSMinX(bounds) + SHAPE_WIDTH, NSMinY(bounds) + SHAPE_WIDTH)];
	[path lineToPoint:NSMakePoint(NSMaxX(bounds), NSMinY(bounds) + SHAPE_WIDTH)];
	[path lineToPoint:NSMakePoint(NSMaxX(bounds), NSMinY(bounds))];
	[path closePath];
	[path gradientFillAtAngle:gradientAngle startColor:[NSColor whiteColor] endColor:[NSColor blackColor]];
}

- (void)takeAngleFrom:sender
{
	angle = -[sender floatValue];
	[self setNeedsDisplay:YES];
}

- (void)takeGradientAngleFrom:sender
{
	gradientAngle = -[sender floatValue];
	[self setNeedsDisplay:YES];	
}


@end
